<template>
  <div>
    <div>
      <el-card class="box-card">
        <el-row style="padding:0;">
          <el-col class="chat-wrap" id="chat-wrap" style="overflow-y: scroll">
            <el-card v-for="(d, index) in discuss" :key="index" class="chat">
              <!-- 강사의 채팅 -->
              <div v-if="d.is_teacher === 1">
                <div class="chat-head">
                  <div>
                    <span style="color: blue; font-weight: bold; font-size: 0.8em">{{ d.user.name }}</span>
                    <span style=" font-size: 0.3vw">({{ d.created_at }})</span>
                  </div>
                  <div style="margin-top: 0.5%">
                    <span style=" font-size: 0.8em">{{ d.content }}</span>
                  </div>
                </div>
              </div>
              <!-- 학생의 채팅 -->
              <div v-else>
                <div class="chat-head">
                  <div>
                    <span style="color: green; font-weight: bold; font-size: 0.8em">{{ d.user.name }}</span>
                    <span style=" font-size: 0.3vw">({{ d.created_at }})</span>
                  </div>
                  <div style="margin-top: 0.5%">
                    <span style=" font-size: 0.8em">{{ d.content }}</span>
                  </div>
                </div>
              </div>
            </el-card>
          </el-col>
        </el-row>
        <hr style="margin-left: -20px; margin-right: -20px">
        <el-row style="padding:0;">
          <el-col>
            <el-form @submit.native.prevent :inline="true" label-width="0px" class="chat-msg-box">
              <el-form-item class="chat-msg">
                <el-input
                  v-if="$isPhone"
                  class="input-chat"
                  type="textarea"
                  :rows="2"
                  v-model="msg"
                  :maxlength="limitLength"
                  @keyup.enter.native="chatSubmit"
                  show-word-limit>
                </el-input>
                <el-input
                  v-if="!$isPhone"
                  class="input-chat"
                  type="textarea"
                  :rows="2"
                  v-model="msg"
                  :maxlength="limitLength"
                  @keyup.enter.native="chatSubmit"
                  show-word-limit>
                </el-input>
              </el-form-item>
              <el-form-item>
                <div class="box">
                  <el-button type="primary" @click="chatSubmit" size="small">{{ $t('DASHBOARD.ENTER') }}</el-button>
                  <el-button type="primary" @click="fileUpload" size="small">{{ $t('DASHBOARD.FILE_UPLOAD') }}</el-button>
                  <!-- <el-button v-if="authType === 1" @click="exportToExcel" size="small">{{ $t('DASHBOARD.REALTIME_CHAT_DOWNLOAD') }}</el-button> -->
                  <!-- <el-button v-if="authType === 1" @click="dialogVisible = true" size="small">{{ $t('DASHBOARD.REALTIME_CHAT_DEL') }}</el-button> -->
                </div>   
              </el-form-item>
            </el-form>
          </el-col>
        </el-row>
      </el-card>
      <!--
      <realtime-webcam-lecture-student
        v-if="authType === 0"
      />
      -->
      <el-dialog
        title="Info"
        :visible.sync="dialogVisible"
        :close-on-click-modal="false"
        :show-close="false"
        width="360px">
        <span>{{ $t('NOTIFY.CHAT_DELETE') }}</span>
        <span slot="footer" class="dialog-footer">
          <el-button type="primary" @click="dialogVisible = false">{{ $t('STUDENT_LECTURE.NO') }}</el-button>
        </span>
      </el-dialog>

      <el-dialog
        :visible.sync="materialVisible"
      >
        <lecture-live-material
        :materialList="materialList"
        :presentMaterial="presentMaterial"
        />
      </el-dialog>

      <el-dialog
        :visible.sync="uploadVisible"
      >
        <el-upload
          class="upload-demo"
          ref="upload"
          action="#"
          :auto-upload="false">
          <el-button slot="trigger" size="small" type="primary">select file</el-button>
          <el-button style="margin-left: 10px;" size="small" type="success" @click="submitUpload">upload to server</el-button>
          <div class="el-upload__tip" slot="tip">jpg/png files with a size less than 500kb</div>
        </el-upload>
      </el-dialog>
      
      <!-- 채팅 내용 엑셀 다운로드를 위한 임시 테이블 -->
      <!-- <table id="chat" :data="discuss">
        <thead v-show="lectureId < 0">
          <tr>
            <td>name</td>
            <td>email</td>
            <td>content</td>
            <td>date</td>
          </tr>
        </thead>
        <tbody v-show="lectureId < 0">
          <tr v-for="(k, index) in discuss" :key="index">
            <td>{{ k.user.name }}</td>
            <td>{{ k.user.email_id }}</td>
            <td>{{ k.content }}</td>
            <td>{{ k.created_at }}</td>
          </tr>
        </tbody>
      </table> -->
    </div>
    <div>
      <el-table :data="fileList" style="width: 100%">
        <el-table-column prop="name" label="파일명">
        </el-table-column>
        <el-table-column prop="user.name" label="게시자" width="180">
        </el-table-column>
        <el-table-column  width="230">
          <template slot-scope="scope">
            <el-button type="primary" @click="downloadFile(scope.row.client_path, scope.row.name)">
              {{ $t('DASHBOARD.DOWNLOAD') }}
            </el-button>
            <el-button type="danger" @click="deleteFile(scope.row.file_guid)" :disabled="checkUploader(scope.row.user)">
              {{ $t('DASHBOARD.DELETE') }}
            </el-button>
          </template>
        </el-table-column>
      </el-table>
    </div>
  </div>
</template>


<style scoped>
  :root {
    --box-width: 100px;
    --box-height: 100px;
    --chat-height: 100px;
    --input-chat-width: 100px;
  }
  .box-card {
    width: var(--box-width);
    height: var(--box-height);
  }
  .chat-msg {
    margin-bottom: 0;
  }
  .chat {
    margin: 2px 2px 2px 0;
  }
  .chat-date {
    float: right;
    color: #aaaaaa;
  }
  .chat-head {
    margin: -10px -10px -10px -10px;
  }
  .chat-wrap {
    height: var(--chat-height);
  }
  .input-chat {
    width: var(--input-chat-width);
  }
  .box {
    display: flex;
    margin: 10px 0px 0px 0px;
  }
</style>

<script>
  import { mapGetters, mapMutations, mapState } from 'vuex';
  import { baseUrl } from '../../services/config';
  import TableExport from 'tableexport';
  import utils from '../../utils';
  import smallGroupChattingService from '../../services/smallGroupChattingService';
  import RealtimeWebcamLectureStudent from '../pages/RealtimeWebcamLectureStudent';
  import lectureService from '../../services/lectureService';
  import fileService from '../../services/fileService';
  import LectureLiveMaterial from '../partials/LectureLiveMaterial';

  export default {
    name: 'SGroupChating',
    async created() {
      const vm = this;
      
      let width = window.innerWidth || document.body.clientWidth;
      let height = window.innerHeight || document.body.clientHeight;
      if (vm.authType === 0) { // 학생인 경우에만 변경
        // 모바일인 경우
        if (vm.authType === 0 && vm.$isPhone) {
          if (width > height) { // 가로모드
            vm.portraitOrLandscape = 'portrait';
            vm.displaySize.width = `${width * 0.8 * 0.88}px`;
            vm.displaySize.height = `${(width * 0.8) * 0.5}px`;
            vm.displaySize.chatHeight = `${((width * 0.8) * 0.6) * 0.3}px`;
            vm.displaySize.inputChatWidth = `${width * 0.8 * 0.85 * 0.8}px`;
          } else {  // 세로모드
            vm.portraitOrLandscape = 'landscape';
            vm.displaySize.width = `${width * 0.8 * 0.85}px`;
            vm.displaySize.height = `${(width * 0.8) * 1.1}px`;
            vm.displaySize.chatHeight = `${((width * 0.8) * 0.4) * 0.8}px`;
            vm.displaySize.inputChatWidth = `${width * 0.8 * 0.85 * 0.8}px`;
          }
        } else {  // PC인 경우
          vm.displaySize.width = `${width * 0.8 * 0.265}px`;
          vm.displaySize.height = `${((width * 0.8 * 0.635) / 16 * 9)}px`;
          vm.displaySize.chatHeight = `${((width * 0.8 * 0.635) / 16 * 9) * 0.6}px`;
          vm.displaySize.inputChatWidth = `${width * 0.8 * 0.265 * 0.85}px`;
        } 
      } else {
        vm.displaySize = {
          width: '400px',
          height: '390px',
          chatHeight: '220px',
          inputChatWidth: '360px',
        }
      }
      
      document.documentElement.style.setProperty('--box-width', vm.displaySize.width);
      document.documentElement.style.setProperty('--box-height', vm.displaySize.height);
      document.documentElement.style.setProperty('--chat-height', vm.displaySize.chatHeight);
      document.documentElement.style.setProperty('--input-chat-width', vm.displaySize.inputChatWidth);

      vm.getFileList(); // 첨부된 파일 목록 가져오기
    },
    async mounted() {
      const vm = this;
      // 새 채팅 온 경우
      window.addEventListener('resize', function() {
        if (vm.authType === 0) { // 학생인 경우에만 변경
          let width = window.innerWidth || document.body.clientWidth;
          let height = window.innerHeight || document.body.clientHeight;
          
          // 모바일인 경우
          if (vm.authType === 0 && vm.$isPhone) {
            if (width > height) { // 가로모드
            vm.portraitOrLandscape = 'portrait';
            vm.displaySize.width = `${width * 0.8 * 0.88}px`;
            vm.displaySize.height = `${(width * 0.8) * 0.5}px`;
            vm.displaySize.chatHeight = `${((width * 0.8) * 0.6) * 0.3}px`;
            vm.displaySize.inputChatWidth = `${width * 0.8 * 0.85 * 0.8}px`;
          } else {  // 세로모드
            vm.portraitOrLandscape = 'landscape';
            vm.displaySize.width = `${width * 0.8 * 0.85}px`;
            vm.displaySize.height = `${(width * 0.8) * 1.1}px`;
            vm.displaySize.chatHeight = `${((width * 0.8) * 0.4) * 0.8}px`;
            vm.displaySize.inputChatWidth = `${width * 0.8 * 0.85 * 0.8}px`;
          }
          } else {  // PC인 경우
            vm.displaySize.width = `${width * 0.8 * 0.265}px`;
            vm.displaySize.height = `${((width * 0.8 * 0.635) / 16 * 9)}px`;
            vm.displaySize.chatHeight = `${((width * 0.8 * 0.635) / 16 * 9) * 0.6}px`;
            vm.displaySize.inputChatWidth = `${width * 0.8 * 0.265 * 0.85}px`;
          }
          document.documentElement.style.setProperty('--box-width', vm.displaySize.width);
          document.documentElement.style.setProperty('--box-height', vm.displaySize.height);
          document.documentElement.style.setProperty('--chat-height', vm.displaySize.chatHeight);
          document.documentElement.style.setProperty('--input-chat-width', vm.displaySize.inputChatWidth);
        }
      }, true);
      vm.sockets.subscribe('ARRIVE_NEW_CHAT_DISCUSSION', (msg) => {
        const jsonMSG = JSON.parse(msg);

        if (jsonMSG.content === '파일을 올렸습니다.' && jsonMSG.content === '파일을 삭제합니다.') {
          vm.getFileList();
        }

        jsonMSG.created_at = utils.formatDate(new Date(jsonMSG.created_at));
        vm.discuss.push(jsonMSG);
        console.log('jsonMSG = ', jsonMSG);
        if (jsonMSG.user_id === null) {
          vm.$notify({
            title: '알 수 없음',
            message: jsonMSG.content,
            type: 'info',
          });
        } else if (jsonMSG.user_id === utils.getUserIdFromJwt()) {
          vm.updating = false;
        } else {
          vm.$notify({
            title: jsonMSG.user.name,
            message: jsonMSG.content,
            type: 'info',
          });
        }
        vm.$forceUpdate();
      });

      const res = await smallGroupChattingService.getChatting({
        room_id: vm.discussionRoomId,
      });
      const discuss = JSON.parse(JSON.stringify(res.data.chatData));
      const dLength = discuss.length;
      for (let i = 0; i < dLength; i += 1) {
        discuss[i].created_at = utils.formatDate(new Date(discuss[i].created_at));
      }
      vm.discuss = discuss;
    },
    updated() {
      const vm = this;
      vm.$nextTick(() => {
        const container = vm.$el.querySelector('#chat-wrap');
        container.scrollTop = container.scrollHeight;
      });
    },
    data() {
      return {
        msg: '',
        isStudent: true,
        pre: -1,
        discuss: [],
        limitLength: null,
        dialogVisible: false,
        displaySize: {
          width: undefined,
          height: undefined,
          chatHeight: undefined,
          inputChatWidth: undefined,
        },
        materialVisible: false,
        materialList: undefined, // 강의자료 목록
        portraitOrLandscape: 'Landscape',
        uploadVisible: false,
        fileList: [],
      };
    },
    computed: {
      discussionRoomId() {
        const vm = this;
        return Number.parseInt(vm.$route.params.roomId, 10);
      },
      authType() {
        return utils.getAuthTypeFromJwt2();
      },
    },
    components: {
      RealtimeWebcamLectureStudent,
      LectureLiveMaterial,
    },
    methods: {
      formatDate: utils.formatDate,
      openInNewTab(url) {
        if (!url.match(/^https?:\/\//i)) {
          url = 'http://' + url;
        }
        window.open(url, '_blank').focus();
      },
      async chatSubmit() {
        const vm = this;
        if (!vm.msg.replace('\n', '')) {
          vm.$notify({
            title: '오류',
            message: '내용을 입력해주세요.',
            type: 'warning',
          });
        } else if (utils.getUserIdFromJwt() === null) {
          vm.$notify({
            title: '오류',
            message: '두 개 이상의 창으로 접속했을 경우, 창 하나로만 접속해주세요. 재접속해주세요.',
            type: 'warning',
          });
        } else {
          const params = {
            discussion_room_id: vm.discussionRoomId,
            user: {
              name: utils.getNameFromJwt(),
              email_id: utils.getEmailFromJwt(),
              user_id: utils.getUserIdFromJwt(),
            },
            content: vm.msg,
          };
          vm.$socket.emit('SEND_NEW_CHAT_DISCUSSION', JSON.stringify(params));
        }
        vm.updating = true;
        vm.msg = '';
      },
      fileUpload() {
        const vm = this;
        vm.uploadVisible = true;
      },
      async getFileList() {
        const vm = this;
        const res1 = await smallGroupChattingService.getFiles({
          room_id: vm.room_id,
        })
        vm.fileList = res1.data.fileList;
      },
      async submitUpload() {
        const vm = this;
        console.log('vm.$refs.upload = ', vm.$refs.upload);
        console.log('vm.$refs.upload.uploadFiles = ', vm.$refs.upload.uploadFiles);
        const uploadFiles = vm.$refs.upload.uploadFiles;
        for ( let i = 0 ; i < uploadFiles.length ; i += 1) {
          await smallGroupChattingService.postFile({
            room_id: vm.room_id,
            file: uploadFiles[i].raw,
          })
        }
        vm.uploadVisible =  false;

        const params = {
          discussion_room_id: vm.discussionRoomId,
          user: {
            name: utils.getNameFromJwt(),
            email_id: utils.getEmailFromJwt(),
            user_id: utils.getUserIdFromJwt(),
          },
          content: '파일을 올렸습니다.',
        };
        vm.$socket.emit('SEND_NEW_CHAT_DISCUSSION', JSON.stringify(params));
        vm.updating = true;
      },
      async downloadFile(client_path, name) {
        utils.downloadFile(baseUrl, {
          client_path,
          name,
        });
      },
      async deleteFile(guid) {
        const vm = this;

        await smallGroupChattingService.deleteFile({
          guid,
        })

        const params = {
          discussion_room_id: vm.discussionRoomId,
          user: {
            name: utils.getNameFromJwt(),
            email_id: utils.getEmailFromJwt(),
            user_id: utils.getUserIdFromJwt(),
          },
          content: '파일을 삭제합니다.',
        };

        vm.$socket.emit('SEND_NEW_CHAT_DISCUSSION', JSON.stringify(params));
        vm.updating = true;
      },
      checkUploader(uploader) {
        const vm = this;
        return (utils.getUserIdFromJwt() !== uploader.user_id);
      },
      // 채팅 내용 엑셀로 다운로드
      exportToExcel() {
        const vm = this;
        TableExport(document.getElementById('chat'), {
          formats: ['xlsx'],
          filename: 'chating',
          sheetname: 'chating',
          position: 'top',
        });
        vm.$notify({
          title: 'Info',
          message: vm.$t('NOTIFY.CHAT_DOWN'),
          type: 'info',
        });
      },
      // async onClick(type) {
      //   const vm = this;
      //   switch (type) {
      //     case 'MATRIALCHECK': {
      //       if (vm.materialVisible === false) {
      //         vm.materialVisible = true;
      //       } else {
      //         vm.materialVisible = false;
      //       }          
      //       break;
      //     }
      //   }
      // },
      presentMaterial(data) {
        const vm = this;
        vm.materialLink = `https://docs.google.com/gview?url=${data}&embedded=true`;
      },
    },
    props: ['room_id'],
  };
</script>
